//
// C++ Interface: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef _MYSQLHELP_IMPL_H
#define _MYSQLHELP_IMPL_H

#include "mysqlhelpdata.h"
#include "kmysqladmin/backend/my_sql/my_sql.h"
#include <qdialog.h>

class ctopiclistviewitem;
class QListViewItem;
/**
@author Rajko Albrecht
*/
class CMysqlhelp : public CMysqlHelpData
{
    Q_OBJECT
public:
    CMysqlhelp(smart_pointer<CMySql>& _sql_server,QWidget* parent=0, const char* name=0, WFlags fl=0);

    virtual ~CMysqlhelp();
    static void disp_testdlg(smart_pointer<CMySql>& _sql_server);

protected slots:
    virtual void keywordSelChanged(QListViewItem*);
    virtual void selbboxDispChanged(int arg1);
    virtual void topicSelChanged();

protected:
    void init_keywords();
    void init_topics();
    void insert_sub_categories(ctopiclistviewitem*parent=0,int dept=0);
    void insert_sub_topics(ctopiclistviewitem*parent);
    void disp_item(ctopiclistviewitem*parent);
    smart_pointer<CMySql> sql_server;
};

/* testing purpose */
class HelpDialog:public QDialog
{
    Q_OBJECT
public:
    HelpDialog(smart_pointer<CMySql>& _sql_server,QWidget *parent = 0, const char *name = 0, bool modal = true, WFlags f = 0);
    virtual ~HelpDialog(){};
protected:
    CMysqlhelp*m_helpview;
};

#endif
