// -*- Mode: C++; -*-
#ifndef CSetupDlg_included
#define CSetupDlg_included

#include "setupdlgdata.h"

class CSetupDlg : public CSetupDlgData
{
    Q_OBJECT
public:
    CSetupDlg(QWidget* parent = NULL,const char* name = NULL);
    virtual ~CSetupDlg();
    const QFont&fixed_font()const;
    const QFont&nonprop_font()const;
    int StatusPolltime()const;
    int ThreadPolltime()const;
    bool Blobimage()const;
    bool Blobscale()const;
    int Blobwidth()const;
    int Blobheight()const;
    bool dispMultiline()const;
    bool compactLayout()const;
    bool oldBrowser()const;
    virtual int exec();


protected:
    QFont m_FixedFont;
    QFont m_NonPropFont;
    int m_ThreadTime;
    int m_StatusTime;
    bool m_Blobimage,m_Blobscale;
    int m_Blobwidth,m_Blobheight;
    bool m_Dispmulti,m_compactLayout,m_oldBrowser;

protected slots: // Protected slots
    virtual void accept();
    virtual void threadTime(int);
    virtual void statusTime(int);
    virtual void fixFontChanged(const QFont&);
    virtual void nonpropFontChanged(const QFont&);
    virtual void blobasImage(bool);
    virtual void imageUnscaled(bool);
    virtual void imageScaled(bool);
    virtual void imageHeight(int);
    virtual void imageWidth(int);
    virtual void dispRealMultiline(bool);
    virtual void compactLayoutToggled( bool );
    virtual void oldBrowserToggled(bool);
};
#endif // CSetupDlg_included


